# This script spools the OUTQ joblogs for all ADMIN* jobs that have the current date.  The output is each spooled
# to a .txt file with its job number, for example /qibm/userdata/httpa/admin/logs/collectorfiles/ADMINxOUTQJoblog123456.txt
touch -C 1252 /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/SCPFJobs.txt

mkdir -p /qibm/userdata/httpa/admin/logs/collectorfiles/AdminJoblogs

DATE=`(date "+%m-%d-%Y")`

system "CRTPF FILE(QGPL/ADMJOBLOGS) RCDLEN(150) MAXMBRS(*NOMAX) SIZE(*NOMAX)"
system "CRTPF FILE(QGPL/SCPFJOBLOG) RCDLEN(150) MAXMBRS(*NOMAX) SIZE(*NOMAX)"
#echo "commenting out ps -tlu due to loop issue.  There will be no joblogs captured."
ps -tlu QWEBADMIN,QLWISVR,QTMHHTTP -o STIME,JOBNAME,STATUS,JOBID | grep -i 'admin*' | grep $DATE  > /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/OUTQAdminJobs.txt

#Gather SCPF joblogs as well
ps -tlu QSYS -o STIME,JOBNAME,STATUS,JOBID | grep -i "scpf"   >   /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/SCPFJobs.txt      

#This cuts out the fully qualified job name of the outq jobs
cat  /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/OUTQAdminJobs.txt | cut -c 42-71 |   
while read line
do
echo $line > /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/JobName.txt
JOBNUMBER=`cut -c 1-6 /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/JobName.txt`  #This cuts out just the job number of the fully qualified job name
#echo ${JOBNUMBER}
system "CPYSPLF FILE(QPJOBLOG) TOFILE(QGPL/ADMJOBLOGS) JOB($line) TOMBR(ADMIN)"
touch -C 1252 /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/AdminJoblogs/ADMINxOUTQJoblog${JOBNUMBER}.txt
system "CPYTOIMPF FROMFILE(QGPL/ADMJOBLOGS ADMIN) TOSTMF('/QIBM/UserData/HTTPA/Admin/logs/collectorfiles/AdminJoblogs/ADMINxOUTQJoblog${JOBNUMBER}.txt') MBROPT(*REPLACE) RCDDLM(*CRLF)"

done


#Process SCPF Jobs

#This cuts out the fully qualified job name of the outq jobs
cat  /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/SCPFJobs.txt | cut -c 42-71 |   
while read line
do
echo $line > /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/SCPFJobName.txt
JOBNUMBER=`cut -c 1-6 /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/SCPFJobName.txt`  #This cuts out just the job number of the fully qualified job name
#echo ${JOBNUMBER}
system "CPYSPLF FILE(QPJOBLOG) TOFILE(QGPL/SCPFJOBLOG) JOB($line) TOMBR(SCPF)"
touch -C 1252 /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/SCPFOUTQJoblog${JOBNUMBER}.txt
system "CPYTOIMPF FROMFILE(QGPL/SCPFJOBLOG SCPF) TOSTMF('/QIBM/UserData/HTTPA/Admin/logs/collectorfiles/SCPFOUTQJoblog${JOBNUMBER}.txt') MBROPT(*REPLACE)  RCDDLM(*CRLF)"

done





system "DLTF FILE(QGPL/ADMJOBLOGS)" 
system "DLTF FILE(QGPL/SCPFJOBLOG)" 
rm /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/JobName.txt
rm /QIBM/UserData/HTTPA/Admin/logs/collectorfiles/OUTQAdminJobs.txt

