#Revised Nov 13 2013 -Altered for QMGTOOLS, added VLOG directory


#########   Instructions for using HTTPcollector script   ###############
# 1. Create a directory on the i5, or use an existing directory, for example:   mkdir '/home/httpcollector'
# 2. place the HTTPcollector script in the directory created, /home/httpcollector.
# 3. strqsh
# 4. cd /home/httpcollector
# 5. HTTPcollector.sh <HTTP Instance Name>
# 6. When finished, it will create a /home/httpcollector/data/<HTTP Instance Name>collector.zip file.
# 7. Please send to ecurep at  http://www.ecurep.ibm.com/app/upload
###############################################################################

export HTTP_INSTANCE=$1
export HTDOCS_RESPONSE=$2
export FTP_RESPONSE=$3
export PMR_NUMBER=$4
export EMAIL_ADDR=$5

echo " "
echo " "
echo "Initiating HTTP collector. This process may take 5-10 minutes."
echo " "
echo " "



DATE=`(date "+%m-%d-%Y")`


if test "${HTTP_INSTANCE}" = ""; then
echo "Please enter the name of the HTTP Server Instance"
read HTTP_INSTANCE
fi

# determines the current location
CURLOC=`(pwd) 2>/dev/null`
mkdir -p ${CURLOC}/data 2>/dev/null



mkdir /tmp 2>/dev/null

#FTP The resulting .zip file to ECUREP using the ecurepFTP.sh script
if test "$FTP_RESPONSE" = ""; then
echo "Do you wish to upload collector data to ecurep? Y or N?"
read FTP_RESPONSE
fi


#Make FTP_RESPONSE UPPERCASE, treat blank or invalid as N
if test "$FTP_RESPONSE" = "y"; then
    FTP_RESPONSE=Y
   elif test "$FTP_RESPONSE" = "Y"; then
    echo "FTP_RESPONSE is YES"
   elif test "$FTP_RESPONSE" = "n"; then
    FTP_RESPONSE=N
   elif test "$FTP_RESPONSE" = "N"; then
    FTP_RESPONSE=N
   
fi

if test "${FTP_RESPONSE}" = "Y"; then
    if test "${PMR_NUMBER}" = ""; then
     echo "Please enter the PMR number in xxxxx.xxx.xxx format"
     read PMR_NUMBER
     fi
     if test "${EMAIL_ADDR}" = ""; then
     echo "Please enter your email address"
     read EMAIL_ADDR
     fi
fi


###Process the QATMHINSTC file to get HTTP Instance Root Information
touch -C 1252 /tmp/${HTTP_INSTANCE}Member.txt
touch -C 1252 /tmp/${HTTP_INSTANCE}Path.txt
system "CPYTOIMPF FROMFILE(QUSRSYS/QATMHINSTC ${HTTP_INSTANCE}) TOSTMF('/tmp/${HTTP_INSTANCE}Member.txt') MBROPT(*REPLACE) RCDDLM(*LFCR)" 2>/dev/null   

cut -f3 -d ' '  /tmp/${HTTP_INSTANCE}Member.txt  >  /tmp/${HTTP_INSTANCE}Path.txt

HTTP_PATH=`cat /tmp/${HTTP_INSTANCE}Path.txt`   
#echo "${HTTP_PATH} is the HTTP_PATH"

# If HTTP_PATH is blank, end the collector.  THis means HTTP server is invalid
if test "${HTTP_PATH}" = ""; then
echo "This is an invalid HTTP server specified, please confirm HTTP server name and rerun HTTPcollector"
exit
fi

# Redirect Errors to ${HTTP_PATH}/logs/HTTPCollectorScriptErrors.txt    
exec 2>${HTTP_PATH}/logs/HTTPCollectorScriptErrors.txt

if test ${HTDOCS_RESPONSE} = ""; then
echo "Do you wish to include the ${HTTP_PATH}/htdocs/ directory?  Y or N?"
read HTDOCS_RESPONSE
fi


### Make HTDOCS_RESPONSE uppercase
if test ${HTDOCS_RESPONSE} = "n"; then
export HTDOCS_RESPONSE='N'
fi
if test ${HTDOCS_RESPONSE} = "y"; then 
export HTDOCS_RESPONSE='Y'
fi

mkdir ${HTTP_PATH}/logs
mkdir ${HTTP_PATH}/logs/collectorfiles

# Redirect Errors to /QIBM/UserData/HTTPA/Admin/logs/httpAdminScriptErrors.txt
exec 2>${HTTP_PATH}/logs/HTTPCollectorScriptErrors.txt

####Create the files with proper CCSID
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/dspptf.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/dspsfwrsc.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/QTMHHTP1.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/QTMHHTTP.txt

touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/cfgtcpopt10.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/cfgtcpopt12.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/${HTTP_INSTANCE}filelist.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/wrkactjob.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/wrksysval.txt


touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/ADMIN2hcReport.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/qatmhinstcAllMembers.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/chghttpa.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/QHTTPSVRdb2www.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/QSYSCGIdb2www.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/QTMJMPS1.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/includes.txt 
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/${HTTP_INSTANCE}Member.txt

echo "Step 1 of 5: Running chkprdopt and testing java"

# determine the OS version and then collects only the data specific to that version
RELEASE=`(uname -r) 2>/dev/null` || RELEASE=unknown
VERSION=`(uname -v) 2>/dev/null` || VERSION=unknown
VRM="unknown"
if [ "$VERSION" = "5" ] && [ "$RELEASE" = "4" ]
then
	VRM="V5R4"
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/JDK14ClassicHello.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/JDK13ClassicHello.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/JDK50QIBMHello.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/chkprdoptR540JV1.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/chkprdoptR540DG1.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/chkprdoptR540SS1Opt3.txt
system "CHKPRDOPT PRDID(5722SS1) OPTION(3)" > ${HTTP_PATH}/logs/collectorfiles/chkprdoptR540SS1Opt3.txt 2> ${HTTP_PATH}/logs/collectorfiles/chkprdoptR540SS1Opt3.txt
system "chkprdopt 5722JV1" > ${HTTP_PATH}/logs/collectorfiles/chkprdoptr540JV1.txt  2> ${HTTP_PATH}/logs/collectorfiles/chkprdoptR540JV1.txt
system "chkprdopt 5722DG1" > ${HTTP_PATH}/logs/collectorfiles/chkprdoptR540DG1.txt  2> ${HTTP_PATH}/logs/collectorfiles/chkprdoptR540DG1.txt

###Perform java tests, this is helpful for Tomcat config problems
java -Djava.version=1.3 -showversion Hello > ${HTTP_PATH}/logs/collectorfiles/JDK13ClassicHello.txt 2> ${HTTP_PATH}/logs/collectorfiles/JDK13ClassicHello.txt
java -Djava.version=1.4 -showversion Hello > ${HTTP_PATH}/logs/collectorfiles/JDK14ClassicHello.txt 2> ${HTTP_PATH}/logs/collectorfiles/JDK14ClassicHello.txt
/QOpenSys/QIBM/ProdData/JavaVM/jdk50/32bit/bin/java  -showversion QIBMHello > ${HTTP_PATH}/logs/collectorfiles/JDK50QIBMHello.txt 2> ${HTTP_PATH}/logs/collectorfiles/JDK50QIBMHello.txt
java PropDump > ${HTTP_PATH}/logs/collectorfiles/PropDump.txt



elif [ "$VERSION" = "6" ] && [ "$RELEASE" = "1" ]
then
	VRM="V6R1"
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/chkprdoptR610JV1.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/chkprdoptR610DG1.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/chkprdoptR610SS1Opt3.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/JDK14ClassicHello.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/JDK50QIBMHello.txt

system "CHKPRDOPT PRDID(5761SS1) OPTION(3)" > ${HTTP_PATH}/logs/collectorfiles/chkprdoptR610SS1Opt3.txt 2> ${HTTP_PATH}/logs/collectorfiles/chkprdoptR610SS1Opt3.txt
system "chkprdopt 5761JV1" > ${HTTP_PATH}/logs/collectorfiles/chkprdoptR610JV1.txt  2> ${HTTP_PATH}/logs/collectorfiles/chkprdoptR610JV1.txt
system "chkprdopt 5761DG1" > ${HTTP_PATH}/logs/collectorfiles/chkprdoptR610DG1.txt  2> ${HTTP_PATH}/logs/collectorfiles/chkprdoptR610DG1.txt

###Perform java tests, this is helpful for Tomcat config problems
java -Djava.version=1.4 -showversion Hello > ${HTTP_PATH}/logs/collectorfiles/JDK14ClassicHello.txt 2> ${HTTP_PATH}/logs/collectorfiles/JDK14ClassicHello.txt
/QOpenSys/QIBM/ProdData/JavaVM/jdk50/32bit/bin/java  -showversion QIBMHello > ${HTTP_PATH}/logs/collectorfiles/JDK50QIBMHello.txt 2> ${HTTP_PATH}/logs/collectorfiles/JDK50QIBMHello.txt

java PropDump > ${HTTP_PATH}/logs/collectorfiles/PropDump.txt


elif [ "$VERSION" = "7" ] && [ "$RELEASE" = "1" ]
then
	VRM="V7R1"
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/chkprdoptR710JV1.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/chkprdoptR710DG1.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/chkprdoptR710SS1Opt3.txt
touch -C 1252 ${HTTP_PATH}/logs/collectorfiles/JDK50QIBMHello.txt
system "chkprdopt 5761JV1" > ${HTTP_PATH}/logs/collectorfiles/chkprdoptR610JV1.txt  2> ${HTTP_PATH}/logs/collectorfiles/chkprdoptR710JV1.txt
system "CHKPRDOPT PRDID(5770SS1) OPTION(3)" > ${HTTP_PATH}/logs/collectorfiles/chkprdoptR710SS1Opt3.txt 2> ${HTTP_PATH}/logs/collectorfiles/chkprdoptR710SS1Opt3.txt
system "chkprdopt 5770DG1" > ${HTTP_PATH}/logs/collectorfiles/chkprdoptR710DG1.txt  2> ${HTTP_PATH}/logs/collectorfiles/chkprdoptR710DG1.txt
/QOpenSys/QIBM/ProdData/JavaVM/jdk50/32bit/bin/java  -showversion QIBMHello > ${HTTP_PATH}/logs/collectorfiles/JDK50QIBMHello.txt 2> ${HTTP_PATH}/logs/collectorfiles/JDK50QIBMHello.txt


fi


echo "Step 2 of 5: Gathering TCP, system commands, ptfs, software resources, dspusrprf"
###Perform system commands, dspusrprf,  file listings####
ls -laR  ${HTTP_PATH} > ${HTTP_PATH}/logs/collectorfiles/${HTTP_INSTANCE}filelist.txt
system dspptf > ${HTTP_PATH}/logs/collectorfiles/dspptf.txt    
system dspsfwrsc > ${HTTP_PATH}/logs/collectorfiles/dspsfwrsc.txt
system "CPYTOIMPF FROMFILE(QUSRSYS/QATOChost hosts) TOSTMF('${HTTP_PATH}/logs/collectorfiles/cfgtcpopt10.txt') MBROPT(*REPLACE) RCDDLM(*CRLF) RMVBLANK(*BOTH) FLDDLM(*TAB)"
system "CPYTOIMPF FROMFILE(QUSRSYS/QATOCtcpip config) TOSTMF('${HTTP_PATH}/logs/collectorfiles/cfgtcpopt12.txt') MBROPT(*REPLACE) RCDDLM(*CRLF) RMVBLANK(*BOTH) FLDDLM(*TAB)"
system wrkactjob > ${HTTP_PATH}/logs/collectorfiles/wrkactjob.txt
system wrksysval > ${HTTP_PATH}/logs/collectorfiles/wrksysval.txt
system "DSPUSRPRF USRPRF(QTMHHTTP) TYPE(*BASIC)" > ${HTTP_PATH}/logs/collectorfiles/qtmhhttp.txt
system "DSPUSRPRF USRPRF(QTMHHTP1) TYPE(*BASIC)" > ${HTTP_PATH}/logs/collectorfiles/QTMHHTP1.txt
system "DSPOBJD OBJ(QHTTPSVR/DB2WWW) OBJTYPE(*PGM) DETAIL(*SERVICE)" > ${HTTP_PATH}/logs/collectorfiles/QHTTPSVRdb2www.txt 2> ${HTTP_PATH}/logs/collectorfiles/QHTTPSVRdb2www.txt
system "DSPOBJD OBJ(QSYSCGI/DB2WWW) OBJTYPE(*PGM) DETAIL(*SERVICE)" > ${HTTP_PATH}/logs/collectorfiles/QSYSCGIdb2www.txt 2> ${HTTP_PATH}/logs/collectorfiles/QSYSCGIdb2www.txt
system "DSPOBJD OBJ(QHTTPSVR/QTMJMPS1) OBJTYPE(*SRVPGM) DETAIL(*SERVICE)" > ${HTTP_PATH}/logs/collectorfiles/QTMJMPS1.txt 2> ${HTTP_PATH}/logs/collectorfiles/QTMJMPS1.txt
system "CPYTOIMPF FROMFILE(QUSRSYS/QATMHTTP config) TOSTMF('${HTTP_PATH}/logs/collectorfiles/chghttpa.txt') MBROPT(*REPLACE) RCDDLM(*CRLF) RMVBLANK(*BOTH) FLDDLM(*TAB)"
system "CPYTOIMPF FROMFILE(QUSRSYS/QATMHINSTC *ALL) TOSTMF('${HTTP_PATH}/logs/collectorfiles/qatmhinstcAllMembers.txt') MBROPT(*REPLACE) RCDDLM(*LFCR)"                                                    
cp /tmp/${HTTP_INSTANCE}Member.txt ${HTTP_PATH}/logs/collectorfiles/${HTTP_INSTANCE}Member.txt

$CURLOC/DSPAUT.sh /qibm/userdata/httpa/conf/mime.types
$CURLOC/DSPAUT.sh ${HTTP_PATH}/conf/httpd.conf
$CURLOC/DSPAUT.sh ${HTTP_PATH}/logs


###Find out what the includes are for the configuration
grep -i 'include /' ${HTTP_PATH}/conf/httpd.conf > ${HTTP_PATH}/logs/collectorfiles/includes.txt     


echo "Step 3 of 5: Running Application Runtime Expert"
###Perform health check for Admin2, this provides helpful data for system
#/QIBM/ProdData/OS/OSGi/LWI71/native/lwihealth.sh admin2 ${HTTP_PATH}/logs/collectorfiles/ADMIN2hcReport.txt
#/QIBM/ProdData/OS/OSGi/healthcheck/bin/runHealthCheck.sh -template /QIBM/ProdData/HTTPA/admin/iashc.jar -outFile ${HTTP_PATH}/logs/collectorfiles/Admin2HealthCheck.txt -property ias.instance.name=admin2

echo "Step 4 of 5:  Gathering joblogs for active and OUTQ HTTP server jobs for last 1 day"
#####Gather Joblogs for the active HTTP server jobs
mkdir ${HTTP_PATH}/logs/collectorfiles/joblogs
#echo "HTTP_INSTANCE is ${HTTP_INSTANCE} "
ps -lu QWEBADMIN,QLWISVR,QTMHHTTP -o JOBNUM,JOBNAME,STIME,STATUS,JOBID | grep -i ${HTTP_INSTANCE} > ${HTTP_PATH}/logs/collectorfiles/ActiveHTTPJobs.txt


cat ${HTTP_PATH}/logs/collectorfiles/ActiveHTTPJobs.txt | cut -c 49-77 |
while read line
do
echo $line > ${HTTP_PATH}/logs/collectorfiles/JobName.txt
JOBNUMBER=`cut -c 1-6 ${HTTP_PATH}/logs/collectorfiles/JobName.txt` > ${HTTP_PATH}/logs/collectorfiles/JobNumber.txt
system "DSPJOBLOG JOB($line)" >> ${HTTP_PATH}/logs/collectorfiles/joblogs/${HTTP_INSTANCE}Joblog${JOBNUMBER}.txt

done

rm ${HTTP_PATH}/logs/collectorfiles/JobName.txt
rm  ${HTTP_PATH}/logs/collectorfiles/JobNumber.txt

#Gather QPJOBLOGs for OUTQ status with today's date
system "CRTPF FILE(QGPL/JOBLOGS) RCDLEN(150) MAXMBRS(*NOMAX) SIZE(*NOMAX)"

ps -tlu QWEBADMIN,QLWISVR,QTMHHTTP -o STIME,JOBNAME,STATUS,JOBID | grep  ${HTTP_INSTANCE}  | grep $DATE >  ${HTTP_PATH}/logs/collectorfiles/OUTQHTTPJobs.txt

#This cuts out the fully qualified job name of the outq jobs
cat  ${HTTP_PATH}/logs/collectorfiles/OUTQHTTPJobs.txt | cut -c 42-71 |

while read line
do
echo $line > $HTTP_PATH/logs/collectorfiles/JobName.txt
JOBNUMBER=`cut -c 1-6 $HTTP_PATH/logs/collectorfiles/JobName.txt`  #This cuts out just the number of the Full job name
echo ${JOBNUMBER}
system "CPYSPLF FILE(QPJOBLOG) TOFILE(QGPL/JOBLOGS) JOB($line) TOMBR(${HTTP_INSTANCE})"
touch -C 1252 $HTTP_PATH/logs/collectorfiles/joblogs/HTTPOUTQJoblog${JOBNUMBER}.txt
system "CPYTOIMPF FROMFILE(QGPL/JOBLOGS ${HTTP_INSTANCE}) TOSTMF('${HTTP_PATH}/logs/collectorfiles/joblogs/HTTPOUTQJoblog${JOBNUMBER}.txt')    MBROPT(*REPLACE) TOCCSID(1252) RCDDLM(*CRLF)"
done

system "DLTF FILE(QGPL/JOBLOGS)"
rm  $HTTP_PATH/logs/collectorfiles/JobName.txt
rm  ${HTTP_PATH}/logs/collectorfiles/OUTQAdminJobs.txt

#Inspect the contents of the httpd.conf file for includes
grep -i 'include /' ${HTTP_PATH}/conf/httpd.conf > ${HTTP_PATH}/logs/collectorfiles/IncludeOutput.txt 
cut -c 9-700 ${HTTP_PATH}/logs/collectorfiles/IncludeOutput.txt > ${HTTP_PATH}/logs/collectorfiles/IncludeFiles.txt

INCLUDE_FILES=`cat ${HTTP_PATH}/logs/collectorfiles/IncludeFiles.txt`

for filename in $INCLUDE_FILES; do
	cp $filename ${HTTP_PATH}/logs/collectorfiles/
done


echo "Step 5 of 5: Zip up data to $CURLOC/data/${HTTP_INSTANCE}collector.zip"
####Depending on answer to include /htdocs, jar appropriate files

if test "${HTDOCS_RESPONSE}" = "Y"; then
jar cvf $CURLOC/data/${HTTP_INSTANCE}collector.zip ${HTTP_PATH}/ \
/qibm/userdata/icss/cert/  \
/QIBM/ProdData/HTTPA/conf/ \
/QIBM/UserData/HTTPA/conf/ \
/tmp/vlogs/ \
/asftomcat/${HTTP_INSTANCE}/  >>  ${HTTP_PATH}/logs/HTTPCollectorZIPOutput.txt

else
jar cvf $CURLOC/data/${HTTP_INSTANCE}collector.zip ${HTTP_PATH}/conf \
${HTTP_PATH}/logs \
${HTTP_PATH}/lwi \
${HTTP_PATH}/wlp/usr/servers/ \
${HTTP_PATH}/webservices/ \
/QIBM/ProdData/HTTPA/conf/ \
/QIBM/UserData/HTTPA/conf/ \
/qibm/userdata/icss/cert/  \
/tmp/vlogs/ \
/asftomcat/${HTTP_INSTANCE}/ >> ${HTTP_PATH}/logs/HTTPCollectorZIPOutput.txt
fi



if test "${FTP_RESPONSE}" = "Y"; then
echo "Attempting to ftp data"
echo "$CURLOC/ecurepFTP.sh data/${HTTP_INSTANCE}collector.zip Y ${PMR_NUMBER} ${EMAIL_ADDR}"
. $CURLOC/ecurepFTP.sh data/${HTTP_INSTANCE}collector.zip Y ${PMR_NUMBER} ${EMAIL_ADDR}
fi

if test -e $CURLOC/data/${HTTP_INSTANCE}collector.zip; then
#m -r ${HTTP_PATH}/logs/collectorfiles/
#rm /tmp/${HTTP_INSTANCE}Path.txt
#rm /tmp/${HTTP_INSTANCE}Member.txt
echo " "
echo " "
echo "$CURLOC/data/${HTTP_INSTANCE}collector.zip file is finished."
if test "${FTP_RESPONSE}" = "N"; then
echo "Please upload to ecurep at http://www.ecurep.ibm.com/app/upload"
echo " "
fi
else
echo "$CURLOC/data/${HTTP_INSTANCE}collector.zip failed to create, possible issue with jar function"
fi


 

