# 09/12/2013 Changes for QMGTOOLS
# 11/17/2010 Changes to checks for Java options installed as CHKPRDOPT changed
# 09/02/2010 added ARE templates for J9 JDK health checking
# 08/05/2010 added call to prehealthchecker app
# 07/20/2010 removed unnecessary java.version property for J9 java calls

export FTP_RESPONSE=$1
export PMR_NUMBER=$2
export EMAIL_ADDR=$3
export QMG_INIT=$4


echo "Step 1 of 8. Inflating jar files..."

# ARE command for running the Java templates
AREcommand="/QIBM/ProdData/OS/OSGi/healthcheck/bin/runARE.sh"

# determines the current location
CURLOC=`(pwd) 2>/dev/null`
mkdir ${CURLOC}/data 2>/dev/null

mkdir $CURLOC/javacollectorfiles/  2>/dev/null
cd $CURLOC/javacollectorfiles/

# Redirect Errors to ${HTTP_PATH}/logs/HTTPCollectorScriptErrors.txt    
exec 2>$CURLOC/javacollectorfiles/javaCollectorScriptErrors.txt


#Unzip the javacollector jars
jar -xvf $CURLOC/jcjars.zip >/dev/null


echo "Step 2 of 8. Running prehealthcheck.."
#Run PreHealthChecker
touch -C 1252 $CURLOC/javacollectorfiles/PreHealthCheck.txt
system "QSYS/CALL PGM(QSYS/QHCRPRECHK)" > $CURLOC/javacollectorfiles/PreHealthCheck.txt


echo "Step 3 of 8. Determine environment..."
# determine the OS version and product ids 
RELEASE=`(uname -r) 2>/dev/null` || RELEASE=unknown
VERSION=`(uname -v) 2>/dev/null` || VERSION=unknown
VRM="unknown"
SS1="unknown"
JV1="unknown"
DG1="unknown"
JC1="5761JC1"
if [ "$VERSION" = "5" ] && [ "$RELEASE" = "4" ]
then
	VRM="V5R4"
	SS1="5722SS1"
        JV1="5722JV1"
	DG1="5722DG1"

        touch -C 1252 $CURLOC/javacollectorfiles/MiscEtc.txt
        ls -laR /qibm/proddata/os400/java400/jdk > $CURLOC/javacollectorfiles/MiscEtc.txt

elif [ "$VERSION" = "6" ] && [ "$RELEASE" = "1" ]
then
	VRM="V6R1"
        SS1="5761SS1"
        JV1="5761JV1"
	DG1="5761DG1" 

        touch -C 1252 $CURLOC/javacollectorfiles/MiscEtc.txt
        ls -laR /qibm/proddata/os/java/jdk/ > $CURLOC/javacollectorfiles/MiscEtc.txt

elif [ "$VERSION" = "7" ] && [ "$RELEASE" = "1" ]
then
	VRM="V7R1"
	SS1="5770SS1"
        JV1="5761JV1"
	DG1="5770DG1"
fi

#record OS version
touch -C 1252 $CURLOC/javacollectorfiles/osversion.txt
echo $VRM > $CURLOC/javacollectorfiles/osversion.txt

echo "Step 4 of 8. Checking Product Options..."
#retrieve product information
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptSS1Opt1.txt
system "CHKPRDOPT PRDID($SS1) OPTION(1)" 2> $CURLOC/javacollectorfiles/chkprdoptSS1Opt1.txt
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptSS1Opt3.txt
system "CHKPRDOPT PRDID($SS1) OPTION(3)" 2> $CURLOC/javacollectorfiles/chkprdoptSS1Opt3.txt
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptSS1Opt12.txt
system "CHKPRDOPT PRDID($SS1) OPTION(12)" 2> $CURLOC/javacollectorfiles/chkprdoptSS1Opt12.txt
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptSS1Opt30.txt
system "CHKPRDOPT PRDID($SS1) OPTION(30)" 2> $CURLOC/javacollectorfiles/chkprdoptSS1Opt30.txt
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptSS1Opt33.txt
system "CHKPRDOPT PRDID($SS1) OPTION(33)" 2> $CURLOC/javacollectorfiles/chkprdoptSS1Opt33.txt
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptJV1Opt6.txt
system "CHKPRDOPT PRDID($JV1) OPTION(6)" 2> $CURLOC/javacollectorfiles/chkprdoptJV1Opt6.txt
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptJV1Opt7.txt
system "CHKPRDOPT PRDID($JV1) OPTION(7)" 2> $CURLOC/javacollectorfiles/chkprdoptJV1Opt7.txt
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptJV1Opt8.txt
system "CHKPRDOPT PRDID($JV1) OPTION(8)" 2> $CURLOC/javacollectorfiles/chkprdoptJV1Opt8.txt
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptJV1Opt9.txt
system "CHKPRDOPT PRDID($JV1) OPTION(9)" 2> $CURLOC/javacollectorfiles/chkprdoptJV1Opt9.txt
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptJV1Opt10.txt
system "CHKPRDOPT PRDID($JV1) OPTION(10)" 2> $CURLOC/javacollectorfiles/chkprdoptJV1Opt10.txt
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptJV1Opt11.txt
system "CHKPRDOPT PRDID($JV1) OPTION(11)" 2> $CURLOC/javacollectorfiles/chkprdoptJV1Opt11.txt
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptJV1Opt12.txt
system "CHKPRDOPT PRDID($JV1) OPTION(12)" 2> $CURLOC/javacollectorfiles/chkprdoptJV1Opt12.txt
touch -C 1252 $CURLOC/javacollectorfiles/chkprdoptJV1Opt13.txt
system "CHKPRDOPT PRDID($JV1) OPTION(13)" 2> $CURLOC/javacollectorfiles/chkprdoptJV1Opt13.txt


ARE="false"
if test -e $AREcommand; then
  ARE="true"
fi

echo "Step 5 of 8. Testing java...."

touch -C 1252 $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt

#Java option 6
MATCH=`find $CURLOC/javacollectorfiles/chkprdoptjv1Opt6.txt -exec grep -c "CPF0C4A" '{}' \; 2>/dev/null` || MATCH=0 
if [ "$MATCH" = "0" ]; then
	touch -C 1252 $CURLOC/javacollectorfiles/JDK14Classic.txt
	java -Djava.version=1.4 -verbose -version > $CURLOC/javacollectorfiles/JDK14Classic.txt 2> $CURLOC/javacollectorfiles/JDK14Classic.txt
	touch -C 1252 $CURLOC/javacollectorfiles/JDK14PropDump.txt
	java -Djava.version=1.4 PropDump > $CURLOC/javacollectorfiles/JDK14PropDump.txt 2> $CURLOC/javacollectorfiles/JDK14PropDump.txt
fi                                                                                                     


#Java option 7
MATCH=`find $CURLOC/javacollectorfiles/chkprdoptjv1Opt7.txt -exec grep -c "CPF0C4A" '{}' \; 2>/dev/null` || MATCH=0 
if [ "$MATCH" = "0" ]; then
	touch -C 1252 $CURLOC/javacollectorfiles/JDK15Classic.txt
	java -Djava.version=1.5 -verbose -version > $CURLOC/javacollectorfiles/JDK15Classic.txt 2> $CURLOC/javacollectorfiles/JDK15Classic.txt
	touch -C 1252 $CURLOC/javacollectorfiles/JDK15PropDump.txt
	java -Djava.version=1.5 PropDump > $CURLOC/javacollectorfiles/JDK15PropDump.txt 2> $CURLOC/javacollectorfiles/JDK15PropDump.txt                                                                    
fi

#Java option 8
MATCH=`find $CURLOC/javacollectorfiles/chkprdoptjv1Opt8.txt -exec grep -c "CPF0C4A" '{}' \; 2>/dev/null` || MATCH=0 
if [ "$MATCH" = "0" ]; then
	touch -C 1252 $CURLOC/javacollectorfiles/JDK50J932.txt
	/QOpenSys/QIBM/ProdData/JavaVM/jdk50/32bit/bin/java -verbose -version > $CURLOC/javacollectorfiles/JDK50J932.txt 2> $CURLOC/javacollectorfiles/JDK50J932.txt 
	touch -C 1252 $CURLOC/javacollectorfiles/JDK50J932QPropDump.txt
	/QOpenSys/QIBM/ProdData/JavaVM/jdk50/32bit/bin/java QPropDump > $CURLOC/javacollectorfiles/JDK50J932QPropDump.txt 2> $CURLOC/javacollectorfiles/JDK50J932QPropDump.txt
        if [ $ARE = "true" ]; then
	    if [ $VRM = "V5R4" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk532result -template $CURLOC/javacollectorfiles/j2se5032Template-v5r4.jar > $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt 
            elif [ $VRM = "V6R1" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk532result -template $CURLOC/javacollectorfiles/j2se5032Template-v6r1.jar >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt 
	    elif [ $VRM = "V7R1" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk532result -template $CURLOC/javacollectorfiles/j2se5032Template.jar >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt
	    fi
	fi
fi

#Java option 9
MATCH=`find $CURLOC/javacollectorfiles/chkprdoptjv1Opt9.txt -exec grep -c "CPF0C4A" '{}' \; 2>/dev/null` || MATCH=0 
if [ "$MATCH" = "0" ]; then
	touch -C 1252 $CURLOC/javacollectorfiles/JDK50J964.txt
	/QOpenSys/QIBM/ProdData/JavaVM/jdk50/64bit/bin/java -verbose -version > $CURLOC/javacollectorfiles/JDK50J964.txt 2> $CURLOC/javacollectorfiles/JDK50J964.txt 
	touch -C 1252 $CURLOC/javacollectorfiles/JDK50J964QPropDump.txt
	/QOpenSys/QIBM/ProdData/JavaVM/jdk50/64bit/bin/java QPropDump > $CURLOC/javacollectorfiles/JDK50J964QPropDump.txt 2> $CURLOC/javacollectorfiles/JDK50J964QPropDump.txt
	if [ $ARE = "true" ]; then
	    if [ $VRM = "V5R4" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk564result -template $CURLOC/javacollectorfiles/j2se5064Template-v5r4.jar >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt 
            elif [ $VRM = "V6R1" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk564result -template $CURLOC/javacollectorfiles/j2se5064Template-v6r1.jar >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt
	    elif [ $VRM = "V7R1" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk564result -template $CURLOC/javacollectorfiles/j2se5064Template.jar >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt
	    fi
	fi
fi

#Java option 10
MATCH=`find $CURLOC/javacollectorfiles/chkprdoptjv1Opt10.txt -exec grep -c "CPF0C4A" '{}' \; 2>/dev/null` || MATCH=0 

if [ "$MATCH" = "0" ]; then
	JDK6=Y
  touch -C 1252 $CURLOC/javacollectorfiles/JDK16Classic.txt
	java -Djava.version=1.6 -verbose -version > $CURLOC/javacollectorfiles/JDK16Classic.txt 2> $CURLOC/javacollectorfiles/JDK16Classic.txt
	touch -C 1252 $CURLOC/javacollectorfiles/JDK16PropDump.txt
	java -Djava.version=1.6 PropDump > $CURLOC/javacollectorfiles/JDK16PropDump.txt 2> $CURLOC/javacollectorfiles/JDK16PropDump.txt
fi

#Java option 11
MATCH=`find $CURLOC/javacollectorfiles/chkprdoptjv1Opt11.txt -exec grep -c "CPF0C4A" '{}' \; 2>/dev/null` || MATCH=0 

if [ "$MATCH" = "0" ]; then
	JDK6=Y
  touch -C 1252 $CURLOC/javacollectorfiles/JDK60J932.txt
	/QOpenSys/QIBM/ProdData/JavaVM/jdk60/32bit/bin/java -verbose -version > $CURLOC/javacollectorfiles/JDK60J932.txt 2> $CURLOC/javacollectorfiles/JDK60J932.txt 
	touch -C 1252 $CURLOC/javacollectorfiles/JDK60J932QPropDump.txt
	/QOpenSys/QIBM/ProdData/JavaVM/jdk60/32bit/bin/java QPropDump > $CURLOC/javacollectorfiles/JDK60J932QPropDump.txt 2> $CURLOC/javacollectorfiles/JDK60J932QPropDump.txt
	if [ $ARE = "true" ]; then
	    if [ $VRM = "V5R4" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk632result -template $CURLOC/javacollectorfiles/j2se6032Template-v5r4.jar >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt 
            elif [ $VRM = "V6R1" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk632result -template $CURLOC/javacollectorfiles/j2se6032Template-v6r1.jar >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt
	    elif [ $VRM = "V7R1" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk632result -template $CURLOC/javacollectorfiles/j2se6032Template.jar  >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt
	    fi
	fi	
fi

#Java option 12
MATCH=`find $CURLOC/javacollectorfiles/chkprdoptjv1Opt12.txt -exec grep -c "CPF0C4A" '{}' \; 2>/dev/null` || MATCH=0 
if [ "$MATCH" = "0" ]; then
	touch -C 1252 $CURLOC/javacollectorfiles/JDK60J964.txt
	/QOpenSys/QIBM/ProdData/JavaVM/jdk60/64bit/bin/java -verbose -version > $CURLOC/javacollectorfiles/JDK60J964.txt 2> $CURLOC/javacollectorfiles/JDK60J964.txt 
	touch -C 1252 $CURLOC/javacollectorfiles/JDK60J964QPropDump.txt
	/QOpenSys/QIBM/ProdData/JavaVM/jdk60/64bit/bin/java QPropDump > $CURLOC/javacollectorfiles/JDK60J964QPropDump.txt 2> $CURLOC/javacollectorfiles/JDK60J964QPropDump.txt
	if [ $ARE = "true" ]; then
	    if [ $VRM = "V5R4" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk664result -template $CURLOC/javacollectorfiles/j2se6064Template-v5r4.jar  >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt
            elif [ $VRM = "V6R1" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk664result -template $CURLOC/javacollectorfiles/j2se6064Template-v6r1.jar >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt
	    elif [ $VRM = "V7R1" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk664result -template $CURLOC/javacollectorfiles/j2se6064Template.jar  >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt
	    fi
	fi
fi

#Java option 13
MATCH=`find $CURLOC/javacollectorfiles/chkprdoptjv1Opt13.txt -exec grep -c "CPF0C4A" '{}' \; 2>/dev/null` || MATCH=0 
if [ "$MATCH" = "0" ]; then
	touch -C 1252 $CURLOC/javacollectorfiles/JDK14J964.txt
	/QOpenSys/QIBM/ProdData/JavaVM/jdk14/64bit/bin/java -verbose -version > $CURLOC/javacollectorfiles/JDK14J964.txt 2> $CURLOC/javacollectorfiles/JDK14J964.txt 
	touch -C 1252 $CURLOC/javacollectorfiles/JDK14J964QPropDump.txt
	/QOpenSys/QIBM/ProdData/JavaVM/jdk14/64bit/bin/java QPropDump > $CURLOC/javacollectorfiles/JDK14J964QPropDump.txt 2> $CURLOC/javacollectorfiles/JDK14J964QPropDump.txt
	if [ $ARE = "true" ]; then
	    if [ $VRM = "V5R4" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk1464result -template $CURLOC/javacollectorfiles/j2se1464Template-v5r4.jar >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt 
            elif [ $VRM = "V6R1" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk1464result -template $CURLOC/javacollectorfiles/j2se1464Template-v6r1.jar >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt
	    elif [ $VRM = "V7R1" ]; then
		$AREcommand -outFile $CURLOC/javacollectorfiles/are_jdk1464result -template $CURLOC/javacollectorfiles/JavaSE1464Template.jar  >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt
	    fi
	fi
fi

echo "Step 6 of 8. Gathering dspptf, dspsfwrsc, wrksyssts, wrksysval..."
#Additional information
touch -C 1252 $CURLOC/javacollectorfiles/dspptf.txt
system "DSPPTF" > $CURLOC/javacollectorfiles/dspptf.txt    

touch -C 1252 $CURLOC/javacollectorfiles/dspsfwrsc.txt
system "DSPSFWRSC" > $CURLOC/javacollectorfiles/dspsfwrsc.txt

touch -C 1252 $CURLOC/javacollectorfiles/wrksyssts.txt   
system "WRKSYSSTS" > $CURLOC/javacollectorfiles/wrksyssts.txt 2> $CURLOC/javacollectorfiles/wrksyssts.txt        

touch -C 1252 $CURLOC/javacollectorfiles/wrksysval.txt
system "WRKSYSVAL" > $CURLOC/javacollectorfiles/wrksysval.txt

touch -C 1252 $CURLOC/javacollectorfiles/export.txt
export > $CURLOC/javacollectorfiles/export.txt

touch -C 1252 $CURLOC/javacollectorfiles/PASElibrary.txt
ls -lrt /QOpenSys/QIBM/ProdData/OS400/PASE/lib > $CURLOC/javacollectorfiles/PASElibrary.txt

touch -C 1252 $CURLOC/javacollectorfiles/RootAttributes.txt   
system "DSPLNK OBJ('/') OUTPUT(*PRINT) OBJTYPE(*ALL) DETAIL(*EXTENDED) DSPOPT(*ALL)"   > $CURLOC/javacollectorfiles/RootAttributes.txt 
  
  
echo "Step 7 of 8. Running Application Runtime Expert...."    
#Collect the Group PTFs, Global Extensions
touch -C 1252 $CURLOC/javacollectorfiles/javaHC.txt
/QIBM/ProdData/OS/OSGi/healthcheck/bin/runHealthCheck.sh -template $CURLOC/javacollectorfiles/javahc.jar -property ias.instance.name=admin -outFile $CURLOC/javacollectorfiles/javaHC.txt  >> $CURLOC/javacollectorfiles/HealthCheckRunStatus.txt

export JAVA_HOME=''

echo "Step 8 of 8. Zipping data..."

jar cf $CURLOC/data/javacollector.zip \
/QIBM/UserData/java400/SystemDefault.properties  \
/home/${LOGNAME}/.profile \
/home/${LOGNAME}/SystemDefault.properties \
$CURLOC/javacollectorfiles

#FTP The resulting .zip file to ECUREP using the ecurepFTP.sh script
#Make FTP_RESPONSE UPPERCASE, treat blank or invalid as N
if test "$FTP_RESPONSE" = "y"; then
    FTP_RESPONSE=Y
   elif test "$FTP_RESPONSE" = "Y"; then
    FTP_RESPONSE=Y
   else
    FTP_RESPONSE=N
fi

cd $CURLOC





if test -e $CURLOC/data/javacollector.zip; then
if test "${FTP_RESPONSE}" = "Y"; then
     if test "${QMG_INIT}" = ""; then
     echo "Attempting to ftp data"

# If the script was initiated from QMGTOOLS, send the data using QMGTOOLS command IBMSSDDUU or FTP2IBM
# If the script was initiated from QSH, then send the data using th ecurepFTP.sh script


      echo "$CURLOC/ecurepFTP.sh data/javacollector.zip Y ${PMR_NUMBER} ${EMAIL_ADDR}"
      . $CURLOC/ecurepFTP.sh data/javacollector.zip Y ${PMR_NUMBER} ${EMAIL_ADDR}
      rm -r $CURLOC/javacollectorfiles/
      else echo "Please select ENTER to start FTP to ECUREP"
      break  
    fi
else echo "$CURLOC/data/javacollector.zip file is finished.  Please send this to service at http://www.ecurep.ibm.com/app/upload "  
fi

#Remove the .txt files that script had produced
rm -r $CURLOC/javacollectorfiles/

else
echo "$CURLOC/data/javacollector.zip file failed to create.  Possible error with jar function"

fi
