############################################################################
##  Automated analysis tool for i5 mail data collection
##  February 2014 -  MJH@US.IBM.COM
## Michael Hjalmervik
## Version 1.0
############################################################################
####
###  Check release to correctly format output
####
# determine the OS version and then collects only the data specific to that version

RELEASE=`(uname -r) 2>/dev/null` || RELEASE=unknown

VERSION=`(uname -v) 2>/dev/null` || VERSION=unknown
echo This system is V $VERSION R $RELEASE
echo ' ' >> /home/mailcollector/files/summary.txt
echo ' ' >> /home/mailcollector/files/summary.txt

mv /home/mailcollector/summary.txt /home/mailcollector/summary.old
touch /home/mailcollector/summary.txt

#CHGSMTPA

echo ' ------------------------------------------------------------------------------------------'
echo 'Mail Router' > /home/mailcollector/files/summary.txt
awk '{if(NR==3)print$0}' /home/mailcollector/files/smtpattr.txt  >> /home/mailcollector/files/summary.txt
RELAY=`awk '{if(NR==3)print$0}' /home/mailcollector/files/smtpattr.txt` 


echo ' ' >> /home/mailcollector/files/summary.txt
echo 'Firewall - Must be *YES if RELAY is intended'  >> /home/mailcollector/files/summary.txt
awk '{if(NR==8)print$0}' /home/mailcollector/files/smtpattr.txt  >> /home/mailcollector/files/summary.txt

echo ' ' >> /home/mailcollector/files/summary.txt
echo 'Allow Relay - if this is *All they are an open relay, *LIST or *NONE is recommended'  >> /home/mailcollector/files/summary.txt
awk '{if(NR==17)print$0}' /home/mailcollector/files/smtpattr.txt  >> /home/mailcollector/files/summary.txt

echo ' ' >> /home/mailcollector/files/summary.txt
echo 'Forwarding Mailhub Server should be the FQDN - SAME as Mailrouter'  >> /home/mailcollector/files/summary.txt
awk '{if(NR==27)print$0}' /home/mailcollector/files/smtpattr.txt  >> /home/mailcollector/files/summary.txt

echo ' ' >> /home/mailcollector/files/summary.txt
echo 'Mailrouter value should be in the local host table CFGTCP option 10'  >> /home/mailcollector/files/summary.txt
grep $RELAY /home/mailcollector/files/cfgtcpopt10.txt  >> /home/mailcollector/files/summary.txt



#CFGTCP option 12
if test ${VERSION} = "7" 
then
echo ' ' >> /home/mailcollector/files/summary.txt
echo 'CFGTCP Option 12 Information' >> /home/mailcollector/files/summary.txt
awk '{if(NR==19)print$0}' /home/mailcollector/files/cfgtcpopt12.txt  >> /home/mailcollector/files/summary.txt
else 
echo 'CFGTCP Option 12 Information' >> /home/mailcollector/files/summary.txt
awk '{if(NR==1)print$0}' /home/mailcollector/files/cfgtcpopt12.txt  >> /home/mailcollector/files/summary.txt
fi


#CFGTCP option 10
#check this to make sure that the bound interface exists on the system-
echo ' ' >> /home/mailcollector/files/summary.txt
echo 'List of the interfaces / hostnames '  >> /home/mailcollector/files/summary.txt
echo 'This should show LOOPBACK & LOCALHOST, as well as the MAILROUTER and FQDN of this machine '  >> /home/mailcollector/files/summary.txt

### cat /home/mailcollector/files/cfgtcpopt10.txt >> /home/mailcollector/files/summary.txt
echo 'Qualified Relay Server listed below'
echo ' '
grep $RELAY /home/mailcollector/files/cfgtcpopt10.txt  >> /home/mailcollector/files/summary.txt
grep LOCALHOST /home/mailcollector/files/cfgtcpopt10.txt  >> /home/mailcollector/files/summary.txt
grep LOOPBACK /home/mailcollector/files/cfgtcpopt10.txt  >> /home/mailcollector/files/summary.txt

#check for bind specific interfaces
echo ' '
echo ' ------------------------------------------------------------------------------'
echo ' '

#WRKACTJOB Scan for MSF and QTSMTP* jobs
echo ' '  >> /home/mailcollector/files/summary.txt
echo 'There should be 3 QMSF jobs and at least 4 QTSMTP* jobs'  >> /home/mailcollector/files/summary.txt
grep QMSF /home/mailcollector/files/wrkactjob.txt  >> /home/mailcollector/files/summary.txt
grep QTSMTP*  /home/mailcollector/files/wrkactjob.txt  >>  /home/mailcollector/files/summary.txt

echo ' '
echo ' ------------------------------------------------------------------------------'
echo ' '

#grep for internet directory entry   
echo ' ' >> /home/mailcollector/files/summary.txt
echo 'The INTERNET GATEWAY needs to exist'  >> /home/mailcollector/files/summary.txt
grep INTERNET /home/mailcollector/files/dspdire.txt  >> /home/mailcollector/files/summary.txt

echo ' '
echo ' ------------------------------------------------------------------------------'
echo ' '

#restricted rename and unlink
echo ' '  >> /home/mailcollector/files/summary.txt

if test  ${VERSION} = "7" 
then
echo ' ' >> /home/mailcollector/files/summary.txt

echo 'Restricted Rename and Unlink should be NO'  >> /home/mailcollector/files/summary.txt
awk '{if(NR==42)print$0}' /home/mailcollector/files/RootAttributes.txt  >> /home/mailcollector/files/summary.txt
else 

echo 'Restricted Rename and Unlink should be NO'  >> /home/mailcollector/files/summary.txt
awk '{if(NR==41)print$0}' /home/mailcollector/files/RootAttributes.txt  >> /home/mailcollector/files/summary.txt
fi

cat /home/mailcollector/files/summary.txt

echo ' ' 
echo ' '
echo 'Hit Enter to Continue --->  '
read $CONTINUE

/home/mailcollector/mail_menu.sh

#####################################################################
######################################################################
